// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: provenance/marker/v1/marker.proto

package types

import (
	fmt "fmt"
	_ "github.com/cosmos/cosmos-proto"
	github_com_cosmos_cosmos_sdk_types "github.com/cosmos/cosmos-sdk/types"
	types "github.com/cosmos/cosmos-sdk/x/auth/types"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	io "io"
	math "math"
	math_bits "math/bits"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// MarkerType defines the types of marker
type MarkerType int32

const (
	// MARKER_TYPE_UNSPECIFIED is an invalid/unknown marker type.
	MarkerType_Unknown MarkerType = 0
	// MARKER_TYPE_COIN is a marker that represents a standard fungible coin (default).
	MarkerType_Coin MarkerType = 1
	// MARKER_TYPE_RESTRICTED is a marker that represents a denom with send_enabled = false.
	MarkerType_RestrictedCoin MarkerType = 2
)

var MarkerType_name = map[int32]string{
	0: "MARKER_TYPE_UNSPECIFIED",
	1: "MARKER_TYPE_COIN",
	2: "MARKER_TYPE_RESTRICTED",
}

var MarkerType_value = map[string]int32{
	"MARKER_TYPE_UNSPECIFIED": 0,
	"MARKER_TYPE_COIN":        1,
	"MARKER_TYPE_RESTRICTED":  2,
}

func (x MarkerType) String() string {
	return proto.EnumName(MarkerType_name, int32(x))
}

func (MarkerType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{0}
}

// MarkerStatus defines the various states a marker account can be in.
type MarkerStatus int32

const (
	// MARKER_STATUS_UNSPECIFIED - Unknown/Invalid Marker Status
	StatusUndefined MarkerStatus = 0
	// MARKER_STATUS_PROPOSED - Initial configuration period, updates allowed, token supply not created.
	StatusProposed MarkerStatus = 1
	// MARKER_STATUS_FINALIZED - Configuration finalized, ready for supply creation
	StatusFinalized MarkerStatus = 2
	// MARKER_STATUS_ACTIVE - Supply is created, rules are in force.
	StatusActive MarkerStatus = 3
	// MARKER_STATUS_CANCELLED - Marker has been cancelled, pending destroy
	StatusCancelled MarkerStatus = 4
	// MARKER_STATUS_DESTROYED - Marker supply has all been recalled, marker is considered destroyed and no further
	// actions allowed.
	StatusDestroyed MarkerStatus = 5
)

var MarkerStatus_name = map[int32]string{
	0: "MARKER_STATUS_UNSPECIFIED",
	1: "MARKER_STATUS_PROPOSED",
	2: "MARKER_STATUS_FINALIZED",
	3: "MARKER_STATUS_ACTIVE",
	4: "MARKER_STATUS_CANCELLED",
	5: "MARKER_STATUS_DESTROYED",
}

var MarkerStatus_value = map[string]int32{
	"MARKER_STATUS_UNSPECIFIED": 0,
	"MARKER_STATUS_PROPOSED":    1,
	"MARKER_STATUS_FINALIZED":   2,
	"MARKER_STATUS_ACTIVE":      3,
	"MARKER_STATUS_CANCELLED":   4,
	"MARKER_STATUS_DESTROYED":   5,
}

func (MarkerStatus) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{1}
}

// Params defines the set of params for the account module.
type Params struct {
	// maximum amount of supply to allow a marker to be created with
	MaxTotalSupply uint64 `protobuf:"varint,1,opt,name=max_total_supply,json=maxTotalSupply,proto3,customtype=uint64" json:"max_total_supply"`
	// indicates if governance based controls of markers is allowed.
	EnableGovernance bool `protobuf:"varint,2,opt,name=enable_governance,json=enableGovernance,proto3" json:"enable_governance,omitempty"`
	// a regular expression used to validate marker denom values from normal create requests (governance
	// requests are only subject to platform coin validation denom expression)
	UnrestrictedDenomRegex string `protobuf:"bytes,3,opt,name=unrestricted_denom_regex,json=unrestrictedDenomRegex,proto3" json:"unrestricted_denom_regex,omitempty"`
}

func (m *Params) Reset()      { *m = Params{} }
func (*Params) ProtoMessage() {}
func (*Params) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{0}
}
func (m *Params) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *Params) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_Params.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *Params) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Params.Merge(m, src)
}
func (m *Params) XXX_Size() int {
	return m.Size()
}
func (m *Params) XXX_DiscardUnknown() {
	xxx_messageInfo_Params.DiscardUnknown(m)
}

var xxx_messageInfo_Params proto.InternalMessageInfo

func (m *Params) GetEnableGovernance() bool {
	if m != nil {
		return m.EnableGovernance
	}
	return false
}

func (m *Params) GetUnrestrictedDenomRegex() string {
	if m != nil {
		return m.UnrestrictedDenomRegex
	}
	return ""
}

// MarkerAccount holds the marker configuration information in addition to a base account structure.
type MarkerAccount struct {
	// base cosmos account information including address and coin holdings.
	*types.BaseAccount `protobuf:"bytes,1,opt,name=base_account,json=baseAccount,proto3,embedded=base_account" json:"base_account,omitempty" yaml:"base_account"`
	// Address that owns the marker configuration.  This account must sign any requests
	// to change marker config (only valid for statuses prior to finalization)
	Manager string `protobuf:"bytes,2,opt,name=manager,proto3" json:"manager,omitempty" json:"manager,omitempty"`
	// Access control lists
	AccessControl []AccessGrant `protobuf:"bytes,3,rep,name=access_control,json=accessControl,proto3" json:"access_control"`
	// Indicates the current status of this marker record.
	Status MarkerStatus `protobuf:"varint,4,opt,name=status,proto3,enum=provenance.marker.v1.MarkerStatus" json:"status,omitempty"`
	// value denomination and total supply for the token.
	Denom string `protobuf:"bytes,5,opt,name=denom,proto3" json:"denom,omitempty"`
	// the total supply expected for a marker.  This is the amount that is minted when a marker is created.
	Supply github_com_cosmos_cosmos_sdk_types.Int `protobuf:"bytes,6,opt,name=supply,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Int" json:"supply" json:"total_supply" yaml:"total_supply"`
	// Marker type information
	MarkerType MarkerType `protobuf:"varint,7,opt,name=marker_type,json=markerType,proto3,enum=provenance.marker.v1.MarkerType" json:"marker_type,omitempty" json:"marker_type,omitempty"`
	// A fixed supply will mint additional coin automatically if the total supply decreases below a set value.  This
	// may occur if the coin is burned or an account holding the coin is slashed. (default: true)
	SupplyFixed bool `protobuf:"varint,8,opt,name=supply_fixed,json=supplyFixed,proto3" json:"supply_fixed,omitempty"`
	// indicates that governance based control is allowed for this marker
	AllowGovernanceControl bool `protobuf:"varint,9,opt,name=allow_governance_control,json=allowGovernanceControl,proto3" json:"allow_governance_control,omitempty"`
}

func (m *MarkerAccount) Reset()      { *m = MarkerAccount{} }
func (*MarkerAccount) ProtoMessage() {}
func (*MarkerAccount) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{1}
}
func (m *MarkerAccount) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *MarkerAccount) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_MarkerAccount.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *MarkerAccount) XXX_Merge(src proto.Message) {
	xxx_messageInfo_MarkerAccount.Merge(m, src)
}
func (m *MarkerAccount) XXX_Size() int {
	return m.Size()
}
func (m *MarkerAccount) XXX_DiscardUnknown() {
	xxx_messageInfo_MarkerAccount.DiscardUnknown(m)
}

var xxx_messageInfo_MarkerAccount proto.InternalMessageInfo

// EventMarkerAdd event emitted when marker is added
type EventMarkerAdd struct {
	Denom      string `protobuf:"bytes,1,opt,name=denom,proto3" json:"denom,omitempty"`
	Amount     string `protobuf:"bytes,2,opt,name=amount,proto3" json:"amount,omitempty"`
	Status     string `protobuf:"bytes,3,opt,name=status,proto3" json:"status,omitempty"`
	Manager    string `protobuf:"bytes,4,opt,name=manager,proto3" json:"manager,omitempty"`
	MarkerType string `protobuf:"bytes,5,opt,name=marker_type,json=markerType,proto3" json:"marker_type,omitempty"`
}

func (m *EventMarkerAdd) Reset()         { *m = EventMarkerAdd{} }
func (m *EventMarkerAdd) String() string { return proto.CompactTextString(m) }
func (*EventMarkerAdd) ProtoMessage()    {}
func (*EventMarkerAdd) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{2}
}
func (m *EventMarkerAdd) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerAdd) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerAdd.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerAdd) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerAdd.Merge(m, src)
}
func (m *EventMarkerAdd) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerAdd) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerAdd.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerAdd proto.InternalMessageInfo

func (m *EventMarkerAdd) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerAdd) GetAmount() string {
	if m != nil {
		return m.Amount
	}
	return ""
}

func (m *EventMarkerAdd) GetStatus() string {
	if m != nil {
		return m.Status
	}
	return ""
}

func (m *EventMarkerAdd) GetManager() string {
	if m != nil {
		return m.Manager
	}
	return ""
}

func (m *EventMarkerAdd) GetMarkerType() string {
	if m != nil {
		return m.MarkerType
	}
	return ""
}

// EventMarkerAddAccess event emitted when marker access is added
type EventMarkerAddAccess struct {
	Access        EventMarkerAccess `protobuf:"bytes,1,opt,name=access,proto3" json:"access"`
	Denom         string            `protobuf:"bytes,2,opt,name=denom,proto3" json:"denom,omitempty"`
	Administrator string            `protobuf:"bytes,3,opt,name=administrator,proto3" json:"administrator,omitempty"`
}

func (m *EventMarkerAddAccess) Reset()         { *m = EventMarkerAddAccess{} }
func (m *EventMarkerAddAccess) String() string { return proto.CompactTextString(m) }
func (*EventMarkerAddAccess) ProtoMessage()    {}
func (*EventMarkerAddAccess) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{3}
}
func (m *EventMarkerAddAccess) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerAddAccess) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerAddAccess.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerAddAccess) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerAddAccess.Merge(m, src)
}
func (m *EventMarkerAddAccess) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerAddAccess) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerAddAccess.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerAddAccess proto.InternalMessageInfo

func (m *EventMarkerAddAccess) GetAccess() EventMarkerAccess {
	if m != nil {
		return m.Access
	}
	return EventMarkerAccess{}
}

func (m *EventMarkerAddAccess) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerAddAccess) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

// EventMarkerAccess event access permissions for address
type EventMarkerAccess struct {
	Address     string   `protobuf:"bytes,1,opt,name=address,proto3" json:"address,omitempty"`
	Permissions []string `protobuf:"bytes,2,rep,name=permissions,proto3" json:"permissions,omitempty"`
}

func (m *EventMarkerAccess) Reset()         { *m = EventMarkerAccess{} }
func (m *EventMarkerAccess) String() string { return proto.CompactTextString(m) }
func (*EventMarkerAccess) ProtoMessage()    {}
func (*EventMarkerAccess) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{4}
}
func (m *EventMarkerAccess) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerAccess) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerAccess.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerAccess) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerAccess.Merge(m, src)
}
func (m *EventMarkerAccess) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerAccess) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerAccess.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerAccess proto.InternalMessageInfo

func (m *EventMarkerAccess) GetAddress() string {
	if m != nil {
		return m.Address
	}
	return ""
}

func (m *EventMarkerAccess) GetPermissions() []string {
	if m != nil {
		return m.Permissions
	}
	return nil
}

// EventMarkerDeleteAccess event emitted when marker access is revoked
type EventMarkerDeleteAccess struct {
	RemoveAddress string `protobuf:"bytes,1,opt,name=remove_address,json=removeAddress,proto3" json:"remove_address,omitempty"`
	Denom         string `protobuf:"bytes,2,opt,name=denom,proto3" json:"denom,omitempty"`
	Administrator string `protobuf:"bytes,3,opt,name=administrator,proto3" json:"administrator,omitempty"`
}

func (m *EventMarkerDeleteAccess) Reset()         { *m = EventMarkerDeleteAccess{} }
func (m *EventMarkerDeleteAccess) String() string { return proto.CompactTextString(m) }
func (*EventMarkerDeleteAccess) ProtoMessage()    {}
func (*EventMarkerDeleteAccess) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{5}
}
func (m *EventMarkerDeleteAccess) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerDeleteAccess) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerDeleteAccess.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerDeleteAccess) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerDeleteAccess.Merge(m, src)
}
func (m *EventMarkerDeleteAccess) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerDeleteAccess) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerDeleteAccess.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerDeleteAccess proto.InternalMessageInfo

func (m *EventMarkerDeleteAccess) GetRemoveAddress() string {
	if m != nil {
		return m.RemoveAddress
	}
	return ""
}

func (m *EventMarkerDeleteAccess) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerDeleteAccess) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

// EventMarkerFinalize event emitted when marker is finalized
type EventMarkerFinalize struct {
	Denom         string `protobuf:"bytes,1,opt,name=denom,proto3" json:"denom,omitempty"`
	Administrator string `protobuf:"bytes,2,opt,name=administrator,proto3" json:"administrator,omitempty"`
}

func (m *EventMarkerFinalize) Reset()         { *m = EventMarkerFinalize{} }
func (m *EventMarkerFinalize) String() string { return proto.CompactTextString(m) }
func (*EventMarkerFinalize) ProtoMessage()    {}
func (*EventMarkerFinalize) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{6}
}
func (m *EventMarkerFinalize) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerFinalize) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerFinalize.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerFinalize) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerFinalize.Merge(m, src)
}
func (m *EventMarkerFinalize) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerFinalize) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerFinalize.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerFinalize proto.InternalMessageInfo

func (m *EventMarkerFinalize) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerFinalize) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

// EventMarkerActivate event emitted when marker is activated
type EventMarkerActivate struct {
	Denom         string `protobuf:"bytes,1,opt,name=denom,proto3" json:"denom,omitempty"`
	Administrator string `protobuf:"bytes,2,opt,name=administrator,proto3" json:"administrator,omitempty"`
}

func (m *EventMarkerActivate) Reset()         { *m = EventMarkerActivate{} }
func (m *EventMarkerActivate) String() string { return proto.CompactTextString(m) }
func (*EventMarkerActivate) ProtoMessage()    {}
func (*EventMarkerActivate) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{7}
}
func (m *EventMarkerActivate) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerActivate) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerActivate.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerActivate) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerActivate.Merge(m, src)
}
func (m *EventMarkerActivate) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerActivate) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerActivate.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerActivate proto.InternalMessageInfo

func (m *EventMarkerActivate) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerActivate) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

// EventMarkerCancel event emitted when marker is cancelled
type EventMarkerCancel struct {
	Denom         string `protobuf:"bytes,1,opt,name=denom,proto3" json:"denom,omitempty"`
	Administrator string `protobuf:"bytes,2,opt,name=administrator,proto3" json:"administrator,omitempty"`
}

func (m *EventMarkerCancel) Reset()         { *m = EventMarkerCancel{} }
func (m *EventMarkerCancel) String() string { return proto.CompactTextString(m) }
func (*EventMarkerCancel) ProtoMessage()    {}
func (*EventMarkerCancel) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{8}
}
func (m *EventMarkerCancel) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerCancel) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerCancel.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerCancel) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerCancel.Merge(m, src)
}
func (m *EventMarkerCancel) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerCancel) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerCancel.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerCancel proto.InternalMessageInfo

func (m *EventMarkerCancel) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerCancel) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

// EventMarkerDelete event emitted when marker is deleted
type EventMarkerDelete struct {
	Denom         string `protobuf:"bytes,1,opt,name=denom,proto3" json:"denom,omitempty"`
	Administrator string `protobuf:"bytes,2,opt,name=administrator,proto3" json:"administrator,omitempty"`
}

func (m *EventMarkerDelete) Reset()         { *m = EventMarkerDelete{} }
func (m *EventMarkerDelete) String() string { return proto.CompactTextString(m) }
func (*EventMarkerDelete) ProtoMessage()    {}
func (*EventMarkerDelete) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{9}
}
func (m *EventMarkerDelete) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerDelete) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerDelete.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerDelete) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerDelete.Merge(m, src)
}
func (m *EventMarkerDelete) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerDelete) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerDelete.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerDelete proto.InternalMessageInfo

func (m *EventMarkerDelete) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerDelete) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

// EventMarkerMint event emitted when additional marker supply is minted
type EventMarkerMint struct {
	Amount        string `protobuf:"bytes,1,opt,name=amount,proto3" json:"amount,omitempty"`
	Denom         string `protobuf:"bytes,2,opt,name=denom,proto3" json:"denom,omitempty"`
	Administrator string `protobuf:"bytes,3,opt,name=administrator,proto3" json:"administrator,omitempty"`
}

func (m *EventMarkerMint) Reset()         { *m = EventMarkerMint{} }
func (m *EventMarkerMint) String() string { return proto.CompactTextString(m) }
func (*EventMarkerMint) ProtoMessage()    {}
func (*EventMarkerMint) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{10}
}
func (m *EventMarkerMint) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerMint) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerMint.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerMint) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerMint.Merge(m, src)
}
func (m *EventMarkerMint) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerMint) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerMint.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerMint proto.InternalMessageInfo

func (m *EventMarkerMint) GetAmount() string {
	if m != nil {
		return m.Amount
	}
	return ""
}

func (m *EventMarkerMint) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerMint) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

// EventMarkerBurn event emitted when coin is burned from marker
type EventMarkerBurn struct {
	Amount        string `protobuf:"bytes,1,opt,name=amount,proto3" json:"amount,omitempty"`
	Denom         string `protobuf:"bytes,2,opt,name=denom,proto3" json:"denom,omitempty"`
	Administrator string `protobuf:"bytes,3,opt,name=administrator,proto3" json:"administrator,omitempty"`
}

func (m *EventMarkerBurn) Reset()         { *m = EventMarkerBurn{} }
func (m *EventMarkerBurn) String() string { return proto.CompactTextString(m) }
func (*EventMarkerBurn) ProtoMessage()    {}
func (*EventMarkerBurn) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{11}
}
func (m *EventMarkerBurn) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerBurn) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerBurn.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerBurn) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerBurn.Merge(m, src)
}
func (m *EventMarkerBurn) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerBurn) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerBurn.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerBurn proto.InternalMessageInfo

func (m *EventMarkerBurn) GetAmount() string {
	if m != nil {
		return m.Amount
	}
	return ""
}

func (m *EventMarkerBurn) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerBurn) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

// EventMarkerWithdraw event emitted when coins are withdrew from marker
type EventMarkerWithdraw struct {
	Coins         string `protobuf:"bytes,1,opt,name=coins,proto3" json:"coins,omitempty"`
	Denom         string `protobuf:"bytes,2,opt,name=denom,proto3" json:"denom,omitempty"`
	Administrator string `protobuf:"bytes,3,opt,name=administrator,proto3" json:"administrator,omitempty"`
	ToAddress     string `protobuf:"bytes,4,opt,name=to_address,json=toAddress,proto3" json:"to_address,omitempty"`
}

func (m *EventMarkerWithdraw) Reset()         { *m = EventMarkerWithdraw{} }
func (m *EventMarkerWithdraw) String() string { return proto.CompactTextString(m) }
func (*EventMarkerWithdraw) ProtoMessage()    {}
func (*EventMarkerWithdraw) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{12}
}
func (m *EventMarkerWithdraw) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerWithdraw) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerWithdraw.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerWithdraw) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerWithdraw.Merge(m, src)
}
func (m *EventMarkerWithdraw) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerWithdraw) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerWithdraw.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerWithdraw proto.InternalMessageInfo

func (m *EventMarkerWithdraw) GetCoins() string {
	if m != nil {
		return m.Coins
	}
	return ""
}

func (m *EventMarkerWithdraw) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerWithdraw) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

func (m *EventMarkerWithdraw) GetToAddress() string {
	if m != nil {
		return m.ToAddress
	}
	return ""
}

// EventMarkerTransfer event emitted when coins are transfered to from account to another
type EventMarkerTransfer struct {
	Amount        string `protobuf:"bytes,1,opt,name=amount,proto3" json:"amount,omitempty"`
	Denom         string `protobuf:"bytes,2,opt,name=denom,proto3" json:"denom,omitempty"`
	Administrator string `protobuf:"bytes,3,opt,name=administrator,proto3" json:"administrator,omitempty"`
	ToAddress     string `protobuf:"bytes,4,opt,name=to_address,json=toAddress,proto3" json:"to_address,omitempty"`
	FromAddress   string `protobuf:"bytes,5,opt,name=from_address,json=fromAddress,proto3" json:"from_address,omitempty"`
}

func (m *EventMarkerTransfer) Reset()         { *m = EventMarkerTransfer{} }
func (m *EventMarkerTransfer) String() string { return proto.CompactTextString(m) }
func (*EventMarkerTransfer) ProtoMessage()    {}
func (*EventMarkerTransfer) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{13}
}
func (m *EventMarkerTransfer) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerTransfer) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerTransfer.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerTransfer) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerTransfer.Merge(m, src)
}
func (m *EventMarkerTransfer) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerTransfer) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerTransfer.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerTransfer proto.InternalMessageInfo

func (m *EventMarkerTransfer) GetAmount() string {
	if m != nil {
		return m.Amount
	}
	return ""
}

func (m *EventMarkerTransfer) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventMarkerTransfer) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

func (m *EventMarkerTransfer) GetToAddress() string {
	if m != nil {
		return m.ToAddress
	}
	return ""
}

func (m *EventMarkerTransfer) GetFromAddress() string {
	if m != nil {
		return m.FromAddress
	}
	return ""
}

// EventMarkerSetDenomMetadata event emitted when metadata is set on marker with denom
type EventMarkerSetDenomMetadata struct {
	MetadataBase        string            `protobuf:"bytes,1,opt,name=metadata_base,json=metadataBase,proto3" json:"metadata_base,omitempty"`
	MetadataDescription string            `protobuf:"bytes,2,opt,name=metadata_description,json=metadataDescription,proto3" json:"metadata_description,omitempty"`
	MetadataDisplay     string            `protobuf:"bytes,3,opt,name=metadata_display,json=metadataDisplay,proto3" json:"metadata_display,omitempty"`
	MetadataDenomUnits  []*EventDenomUnit `protobuf:"bytes,4,rep,name=metadata_denom_units,json=metadataDenomUnits,proto3" json:"metadata_denom_units,omitempty"`
	Administrator       string            `protobuf:"bytes,5,opt,name=administrator,proto3" json:"administrator,omitempty"`
	MetadataName        string            `protobuf:"bytes,6,opt,name=metadata_name,json=metadataName,proto3" json:"metadata_name,omitempty"`
	MetadataSymbol      string            `protobuf:"bytes,7,opt,name=metadata_symbol,json=metadataSymbol,proto3" json:"metadata_symbol,omitempty"`
}

func (m *EventMarkerSetDenomMetadata) Reset()         { *m = EventMarkerSetDenomMetadata{} }
func (m *EventMarkerSetDenomMetadata) String() string { return proto.CompactTextString(m) }
func (*EventMarkerSetDenomMetadata) ProtoMessage()    {}
func (*EventMarkerSetDenomMetadata) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{14}
}
func (m *EventMarkerSetDenomMetadata) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventMarkerSetDenomMetadata) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventMarkerSetDenomMetadata.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventMarkerSetDenomMetadata) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventMarkerSetDenomMetadata.Merge(m, src)
}
func (m *EventMarkerSetDenomMetadata) XXX_Size() int {
	return m.Size()
}
func (m *EventMarkerSetDenomMetadata) XXX_DiscardUnknown() {
	xxx_messageInfo_EventMarkerSetDenomMetadata.DiscardUnknown(m)
}

var xxx_messageInfo_EventMarkerSetDenomMetadata proto.InternalMessageInfo

func (m *EventMarkerSetDenomMetadata) GetMetadataBase() string {
	if m != nil {
		return m.MetadataBase
	}
	return ""
}

func (m *EventMarkerSetDenomMetadata) GetMetadataDescription() string {
	if m != nil {
		return m.MetadataDescription
	}
	return ""
}

func (m *EventMarkerSetDenomMetadata) GetMetadataDisplay() string {
	if m != nil {
		return m.MetadataDisplay
	}
	return ""
}

func (m *EventMarkerSetDenomMetadata) GetMetadataDenomUnits() []*EventDenomUnit {
	if m != nil {
		return m.MetadataDenomUnits
	}
	return nil
}

func (m *EventMarkerSetDenomMetadata) GetAdministrator() string {
	if m != nil {
		return m.Administrator
	}
	return ""
}

func (m *EventMarkerSetDenomMetadata) GetMetadataName() string {
	if m != nil {
		return m.MetadataName
	}
	return ""
}

func (m *EventMarkerSetDenomMetadata) GetMetadataSymbol() string {
	if m != nil {
		return m.MetadataSymbol
	}
	return ""
}

// EventDenomUnit denom units for set denom metadata event
type EventDenomUnit struct {
	Denom    string   `protobuf:"bytes,1,opt,name=denom,proto3" json:"denom,omitempty"`
	Exponent string   `protobuf:"bytes,2,opt,name=exponent,proto3" json:"exponent,omitempty"`
	Aliases  []string `protobuf:"bytes,3,rep,name=aliases,proto3" json:"aliases,omitempty"`
}

func (m *EventDenomUnit) Reset()         { *m = EventDenomUnit{} }
func (m *EventDenomUnit) String() string { return proto.CompactTextString(m) }
func (*EventDenomUnit) ProtoMessage()    {}
func (*EventDenomUnit) Descriptor() ([]byte, []int) {
	return fileDescriptor_f7e2c25c71db7f99, []int{15}
}
func (m *EventDenomUnit) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EventDenomUnit) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EventDenomUnit.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EventDenomUnit) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EventDenomUnit.Merge(m, src)
}
func (m *EventDenomUnit) XXX_Size() int {
	return m.Size()
}
func (m *EventDenomUnit) XXX_DiscardUnknown() {
	xxx_messageInfo_EventDenomUnit.DiscardUnknown(m)
}

var xxx_messageInfo_EventDenomUnit proto.InternalMessageInfo

func (m *EventDenomUnit) GetDenom() string {
	if m != nil {
		return m.Denom
	}
	return ""
}

func (m *EventDenomUnit) GetExponent() string {
	if m != nil {
		return m.Exponent
	}
	return ""
}

func (m *EventDenomUnit) GetAliases() []string {
	if m != nil {
		return m.Aliases
	}
	return nil
}

func init() {
	proto.RegisterEnum("provenance.marker.v1.MarkerType", MarkerType_name, MarkerType_value)
	proto.RegisterEnum("provenance.marker.v1.MarkerStatus", MarkerStatus_name, MarkerStatus_value)
	proto.RegisterType((*Params)(nil), "provenance.marker.v1.Params")
	proto.RegisterType((*MarkerAccount)(nil), "provenance.marker.v1.MarkerAccount")
	proto.RegisterType((*EventMarkerAdd)(nil), "provenance.marker.v1.EventMarkerAdd")
	proto.RegisterType((*EventMarkerAddAccess)(nil), "provenance.marker.v1.EventMarkerAddAccess")
	proto.RegisterType((*EventMarkerAccess)(nil), "provenance.marker.v1.EventMarkerAccess")
	proto.RegisterType((*EventMarkerDeleteAccess)(nil), "provenance.marker.v1.EventMarkerDeleteAccess")
	proto.RegisterType((*EventMarkerFinalize)(nil), "provenance.marker.v1.EventMarkerFinalize")
	proto.RegisterType((*EventMarkerActivate)(nil), "provenance.marker.v1.EventMarkerActivate")
	proto.RegisterType((*EventMarkerCancel)(nil), "provenance.marker.v1.EventMarkerCancel")
	proto.RegisterType((*EventMarkerDelete)(nil), "provenance.marker.v1.EventMarkerDelete")
	proto.RegisterType((*EventMarkerMint)(nil), "provenance.marker.v1.EventMarkerMint")
	proto.RegisterType((*EventMarkerBurn)(nil), "provenance.marker.v1.EventMarkerBurn")
	proto.RegisterType((*EventMarkerWithdraw)(nil), "provenance.marker.v1.EventMarkerWithdraw")
	proto.RegisterType((*EventMarkerTransfer)(nil), "provenance.marker.v1.EventMarkerTransfer")
	proto.RegisterType((*EventMarkerSetDenomMetadata)(nil), "provenance.marker.v1.EventMarkerSetDenomMetadata")
	proto.RegisterType((*EventDenomUnit)(nil), "provenance.marker.v1.EventDenomUnit")
}

func init() { proto.RegisterFile("provenance/marker/v1/marker.proto", fileDescriptor_f7e2c25c71db7f99) }

var fileDescriptor_f7e2c25c71db7f99 = []byte{
	// 1384 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb4, 0x57, 0xcd, 0x6f, 0x13, 0x47,
	0x1b, 0xf7, 0x3a, 0x89, 0x89, 0xc7, 0x89, 0x31, 0x93, 0x28, 0x18, 0xc3, 0x6b, 0x2f, 0xfb, 0xf2,
	0x82, 0x5f, 0xde, 0x17, 0xbb, 0x49, 0x2b, 0x84, 0x72, 0xf3, 0x57, 0x90, 0x55, 0x92, 0xb8, 0x6b,
	0x87, 0x0a, 0x54, 0x69, 0x3b, 0xf6, 0x4e, 0xcc, 0x96, 0xdd, 0x19, 0x77, 0x77, 0x6c, 0xe2, 0xaa,
	0x67, 0x84, 0x72, 0x6a, 0x6f, 0xad, 0xd4, 0x48, 0x48, 0xed, 0xa1, 0x52, 0x8f, 0xed, 0xb9, 0x67,
	0xd4, 0x13, 0xc7, 0xaa, 0x07, 0xab, 0x82, 0x4b, 0x0f, 0x3d, 0xe5, 0x2f, 0xa8, 0x76, 0x66, 0xbc,
	0x5e, 0x37, 0x06, 0x0e, 0x29, 0x27, 0xef, 0x3c, 0xcf, 0xef, 0xf9, 0xfa, 0x3d, 0xcf, 0x7c, 0x18,
	0x5c, 0xee, 0xb9, 0x74, 0x80, 0x09, 0x22, 0x1d, 0x5c, 0x74, 0x90, 0xfb, 0x10, 0xbb, 0xc5, 0xc1,
	0xba, 0xfc, 0x2a, 0xf4, 0x5c, 0xca, 0x28, 0x5c, 0x9d, 0x40, 0x0a, 0x52, 0x31, 0x58, 0xcf, 0xac,
	0x76, 0x69, 0x97, 0x72, 0x40, 0xd1, 0xff, 0x12, 0xd8, 0x4c, 0xb6, 0x43, 0x3d, 0x87, 0x7a, 0x45,
	0xd4, 0x67, 0x0f, 0x8a, 0x83, 0xf5, 0x36, 0x66, 0x68, 0x9d, 0x2f, 0xa4, 0xfe, 0x82, 0xd0, 0x1b,
	0xc2, 0x50, 0x2c, 0xa4, 0xea, 0xea, 0xcc, 0x4c, 0x50, 0xa7, 0x83, 0x3d, 0xaf, 0xeb, 0x22, 0xc2,
	0x04, 0x4e, 0xfb, 0x51, 0x01, 0xb1, 0x06, 0x72, 0x91, 0xe3, 0xc1, 0x5b, 0x20, 0xe5, 0xa0, 0x03,
	0x83, 0x51, 0x86, 0x6c, 0xc3, 0xeb, 0xf7, 0x7a, 0xf6, 0x30, 0xad, 0xa8, 0x4a, 0x7e, 0xbe, 0x9c,
	0x7c, 0x36, 0xca, 0x45, 0x7e, 0x1b, 0xe5, 0x62, 0x7d, 0x8b, 0xb0, 0x9b, 0xef, 0xe9, 0x49, 0x07,
	0x1d, 0xb4, 0x7c, 0x58, 0x93, 0xa3, 0xe0, 0xff, 0xc0, 0x39, 0x4c, 0x50, 0xdb, 0xc6, 0x46, 0x97,
	0x0e, 0xb0, 0xcb, 0xa3, 0xa6, 0xa3, 0xaa, 0x92, 0x5f, 0xd4, 0x53, 0x42, 0x71, 0x3b, 0x90, 0xc3,
	0x5b, 0x20, 0xdd, 0x27, 0x2e, 0xf6, 0x98, 0x6b, 0x75, 0x18, 0x36, 0x0d, 0x13, 0x13, 0xea, 0x18,
	0x2e, 0xee, 0xe2, 0x83, 0xf4, 0x9c, 0xaa, 0xe4, 0xe3, 0xfa, 0x5a, 0x58, 0x5f, 0xf5, 0xd5, 0xba,
	0xaf, 0xdd, 0x5c, 0xfc, 0xea, 0x69, 0x2e, 0xf2, 0xc7, 0xd3, 0x5c, 0x44, 0xfb, 0x66, 0x01, 0x2c,
	0x6f, 0xf3, 0xaa, 0x4a, 0x9d, 0x0e, 0xed, 0x13, 0x06, 0x3f, 0x06, 0x4b, 0x6d, 0xe4, 0x61, 0x03,
	0x89, 0x35, 0x4f, 0x3c, 0xb1, 0xa1, 0x16, 0x24, 0x29, 0x9c, 0x34, 0xc9, 0x60, 0xa1, 0x8c, 0x3c,
	0x2c, 0xed, 0xca, 0x17, 0x9f, 0x8f, 0x72, 0xca, 0xf1, 0x28, 0xb7, 0x32, 0x44, 0x8e, 0xbd, 0xa9,
	0x85, 0x7d, 0x68, 0x7a, 0xa2, 0x3d, 0x41, 0xc2, 0x9b, 0xe0, 0x8c, 0x83, 0x08, 0xea, 0x62, 0x97,
	0x97, 0x16, 0x2f, 0x5f, 0x3a, 0x1e, 0xe5, 0xd2, 0x9f, 0x78, 0x94, 0x6c, 0x6a, 0x52, 0xf1, 0x7f,
	0xea, 0x58, 0x0c, 0x3b, 0x3d, 0x36, 0xd4, 0xf4, 0x31, 0x18, 0xee, 0x80, 0xa4, 0xa0, 0xdd, 0xe8,
	0x50, 0xc2, 0x5c, 0x6a, 0xa7, 0xe7, 0xd4, 0xb9, 0x7c, 0x62, 0xe3, 0x72, 0x61, 0xd6, 0x24, 0x14,
	0x4a, 0x1c, 0x7b, 0xdb, 0x6f, 0x51, 0x79, 0xde, 0xe7, 0x5d, 0x5f, 0x16, 0xe6, 0x15, 0x61, 0x0d,
	0x37, 0x41, 0xcc, 0x63, 0x88, 0xf5, 0xbd, 0xf4, 0xbc, 0xaa, 0xe4, 0x93, 0x1b, 0xda, 0x6c, 0x3f,
	0x82, 0x9e, 0x26, 0x47, 0xea, 0xd2, 0x02, 0xae, 0x82, 0x05, 0x4e, 0x77, 0x7a, 0x81, 0x13, 0x2d,
	0x16, 0xf0, 0x53, 0x10, 0x93, 0xed, 0x8e, 0xf1, 0xc2, 0xee, 0xc9, 0x76, 0x5f, 0xed, 0x5a, 0xec,
	0x41, 0xbf, 0x5d, 0xe8, 0x50, 0x47, 0x0e, 0x97, 0xfc, 0xb9, 0xe1, 0x99, 0x0f, 0x8b, 0x6c, 0xd8,
	0xc3, 0x5e, 0xa1, 0x4e, 0xd8, 0xf1, 0x28, 0x77, 0x4d, 0xd0, 0x10, 0x1e, 0x1d, 0x4d, 0x15, 0x8c,
	0x4e, 0xc9, 0x74, 0x19, 0x08, 0x76, 0x40, 0x42, 0xa4, 0x6a, 0xf8, 0x6e, 0xd2, 0x67, 0x78, 0x25,
	0xea, 0xeb, 0x2a, 0x69, 0x0d, 0x7b, 0xb8, 0xac, 0x1e, 0x8f, 0x72, 0x97, 0xc6, 0x94, 0x07, 0xe6,
	0x61, 0xda, 0x81, 0x13, 0xa0, 0xe1, 0x65, 0xb0, 0x24, 0xc2, 0x19, 0xfb, 0xd6, 0x01, 0x36, 0xd3,
	0x8b, 0x7c, 0x22, 0x13, 0x42, 0xb6, 0xe5, 0x8b, 0xfc, 0x61, 0x44, 0xb6, 0x4d, 0x1f, 0x85, 0x06,
	0x37, 0x68, 0x53, 0x9c, 0xc3, 0xd7, 0xb8, 0x7e, 0x32, 0xbf, 0xb2, 0x0d, 0x9b, 0x99, 0x27, 0x4f,
	0x73, 0x11, 0x7f, 0x20, 0x7f, 0xf9, 0xe9, 0x46, 0x72, 0x6a, 0x16, 0xeb, 0xda, 0x97, 0x0a, 0x48,
	0xd6, 0x06, 0x98, 0x30, 0x29, 0x37, 0xcd, 0x09, 0xf3, 0x4a, 0x98, 0xf9, 0x35, 0x10, 0x43, 0x0e,
	0x9f, 0x57, 0x3e, 0x52, 0xba, 0x5c, 0xf9, 0x72, 0xd9, 0x63, 0xb1, 0x23, 0xc6, 0xfd, 0x4b, 0x4f,
	0x66, 0x70, 0x9e, 0x2b, 0x82, 0x29, 0xcb, 0x4d, 0x13, 0x2a, 0xfa, 0x1b, 0x22, 0x43, 0xfb, 0x5a,
	0x01, 0xab, 0xd3, 0x39, 0x89, 0x49, 0x83, 0x35, 0x10, 0x13, 0x03, 0x26, 0xf7, 0xcc, 0xb5, 0xd9,
	0x5d, 0x08, 0xdb, 0x72, 0xb8, 0x9c, 0x4e, 0x69, 0x3c, 0x29, 0x30, 0x1a, 0x2e, 0xf0, 0x0a, 0x58,
	0x46, 0xa6, 0x63, 0x11, 0xcb, 0x63, 0x2e, 0x62, 0xd4, 0x95, 0xf5, 0x4c, 0x0b, 0xb5, 0x5d, 0x70,
	0xee, 0x84, 0x7b, 0xbf, 0x56, 0x64, 0x9a, 0xee, 0x38, 0xb1, 0xb8, 0x3e, 0x5e, 0x42, 0x15, 0x24,
	0x7a, 0xd8, 0x75, 0x2c, 0xcf, 0xb3, 0x28, 0xf1, 0xd2, 0x51, 0x75, 0x2e, 0x1f, 0xd7, 0xc3, 0x22,
	0xed, 0x73, 0x70, 0x3e, 0xe4, 0xb0, 0x8a, 0x6d, 0xcc, 0xb0, 0x74, 0xfb, 0x1f, 0x90, 0x74, 0xb1,
	0x43, 0x07, 0xd8, 0x98, 0xf6, 0xbe, 0x2c, 0xa4, 0x25, 0x19, 0xe3, 0x34, 0xe5, 0x7c, 0x00, 0x56,
	0x42, 0xd1, 0xb7, 0x2c, 0x82, 0x6c, 0xeb, 0x33, 0xfc, 0x8a, 0x11, 0x38, 0xe1, 0x32, 0xfa, 0x66,
	0x97, 0xa5, 0x0e, 0xb3, 0x06, 0x88, 0x9d, 0xce, 0xe5, 0x34, 0xe9, 0x15, 0xbf, 0xdd, 0xf6, 0x3f,
	0xe8, 0x50, 0x90, 0x7e, 0x2a, 0x87, 0x18, 0x9c, 0x0d, 0x39, 0xdc, 0xb6, 0xc4, 0xc6, 0x90, 0x1b,
	0x46, 0x99, 0xda, 0x30, 0xa7, 0x69, 0xd7, 0x74, 0x98, 0x72, 0xdf, 0x25, 0x6f, 0x25, 0xcc, 0x63,
	0x65, 0xaa, 0x87, 0x1f, 0x5a, 0xec, 0x81, 0xe9, 0xa2, 0x47, 0xbe, 0xcf, 0x0e, 0xb5, 0xc8, 0x78,
	0x0e, 0xc5, 0xe2, 0x34, 0x91, 0xe0, 0xbf, 0x00, 0x60, 0x34, 0x18, 0x6f, 0x71, 0x50, 0xc4, 0x19,
	0x95, 0xa3, 0xad, 0xfd, 0x30, 0x9d, 0x48, 0xcb, 0x45, 0xc4, 0xdb, 0xc7, 0xee, 0xdb, 0x28, 0xfa,
	0x0d, 0xa9, 0xf8, 0x27, 0xf4, 0xbe, 0x4b, 0x9d, 0x00, 0x20, 0x8e, 0xad, 0x84, 0x2f, 0x1b, 0x67,
	0xfb, 0x67, 0x14, 0x5c, 0x0c, 0x65, 0xdb, 0xc4, 0x8c, 0xbf, 0x08, 0xb6, 0x31, 0x43, 0x26, 0x62,
	0x08, 0xfe, 0x1b, 0x2c, 0x3b, 0xf2, 0xdb, 0xf0, 0xaf, 0x6b, 0x99, 0xfc, 0xd2, 0x58, 0xe8, 0x5f,
	0xf6, 0x70, 0x1d, 0xac, 0x06, 0x20, 0x13, 0x7b, 0x1d, 0xd7, 0xea, 0x31, 0x8b, 0x12, 0x59, 0xd1,
	0xca, 0x58, 0x57, 0x9d, 0xa8, 0xe0, 0x7f, 0x41, 0x6a, 0x62, 0x62, 0x79, 0x3d, 0x1b, 0x0d, 0x65,
	0x89, 0x67, 0x03, 0xb8, 0x10, 0xc3, 0xbb, 0x53, 0xde, 0xfd, 0xd7, 0x4c, 0x9f, 0x58, 0xcc, 0x2f,
	0xd7, 0xbf, 0xe7, 0xaf, 0xbc, 0xe6, 0x3c, 0xe5, 0xa5, 0xec, 0x11, 0x8b, 0xe9, 0x70, 0x92, 0x83,
	0x14, 0x79, 0x27, 0x29, 0x5e, 0x98, 0x45, 0x71, 0x98, 0x00, 0x82, 0x1c, 0x2c, 0x2e, 0xf1, 0x09,
	0x01, 0x3b, 0xc8, 0xc1, 0xf0, 0x1a, 0x08, 0xb2, 0x36, 0xbc, 0xa1, 0xd3, 0xa6, 0x36, 0xbf, 0x73,
	0xe3, 0x7a, 0x72, 0x2c, 0x6e, 0x72, 0xa9, 0xf6, 0x91, 0xbc, 0xb9, 0x82, 0x34, 0x5e, 0xb1, 0x83,
	0x33, 0x60, 0x11, 0x1f, 0xf4, 0x28, 0xc1, 0xc1, 0xdd, 0x15, 0xac, 0xf9, 0xc9, 0x6d, 0x5b, 0xc8,
	0xc3, 0x1e, 0x7f, 0xea, 0xf8, 0x27, 0xb7, 0x58, 0x5e, 0x7f, 0xac, 0x00, 0x30, 0xb9, 0xce, 0x61,
	0x1e, 0x9c, 0xdf, 0x2e, 0xe9, 0xef, 0xd7, 0x74, 0xa3, 0x75, 0xaf, 0x51, 0x33, 0xf6, 0x76, 0x9a,
	0x8d, 0x5a, 0xa5, 0xbe, 0x55, 0xaf, 0x55, 0x53, 0x91, 0x4c, 0xe2, 0xf0, 0x48, 0x3d, 0xb3, 0x47,
	0x1e, 0x12, 0xfa, 0x88, 0xc0, 0x2c, 0x48, 0x85, 0x91, 0x95, 0xdd, 0xfa, 0x4e, 0x4a, 0xc9, 0x2c,
	0x1e, 0x1e, 0xa9, 0xf3, 0x15, 0x6a, 0x11, 0x58, 0x00, 0x6b, 0x61, 0xbd, 0x5e, 0x6b, 0xb6, 0xf4,
	0x7a, 0xa5, 0x55, 0xab, 0xa6, 0xa2, 0x19, 0x78, 0x78, 0xa4, 0x26, 0xf5, 0xe0, 0x41, 0xe9, 0xe3,
	0xaf, 0xff, 0x1c, 0x05, 0x4b, 0xe1, 0x17, 0x12, 0xdc, 0x00, 0x17, 0xa4, 0x83, 0x66, 0xab, 0xd4,
	0xda, 0x6b, 0xfe, 0x2d, 0x99, 0x95, 0xc3, 0x23, 0xf5, 0xac, 0x80, 0xee, 0x11, 0x13, 0xef, 0x5b,
	0x04, 0x9b, 0xa1, 0xa0, 0xd2, 0xa6, 0xa1, 0xef, 0x36, 0x76, 0x9b, 0xb5, 0x6a, 0x4a, 0x11, 0x41,
	0x85, 0x41, 0xc3, 0xa5, 0x3d, 0xea, 0x61, 0x13, 0xbe, 0x13, 0x94, 0x2b, 0xf1, 0x5b, 0xf5, 0x9d,
	0xd2, 0x9d, 0xfa, 0x7d, 0x9e, 0x65, 0x28, 0xc2, 0xf8, 0xc6, 0x30, 0xe1, 0x75, 0xb0, 0x3a, 0x6d,
	0x51, 0xaa, 0xb4, 0xea, 0x77, 0x6b, 0xa9, 0xb9, 0x4c, 0xea, 0xf0, 0x48, 0x5d, 0x12, 0x70, 0x7e,
	0x1b, 0xe0, 0x93, 0xde, 0x2b, 0xa5, 0x9d, 0x4a, 0xed, 0xce, 0x9d, 0x5a, 0x35, 0x35, 0x1f, 0xf6,
	0x2e, 0x4e, 0x7a, 0x7b, 0x56, 0x3e, 0x55, 0x9f, 0xb6, 0xdd, 0x7b, 0xb5, 0x6a, 0x6a, 0x21, 0x6c,
	0x51, 0xf5, 0xb9, 0xa3, 0x43, 0x6c, 0x66, 0x16, 0x9f, 0x7c, 0x9b, 0x8d, 0x7c, 0xff, 0x5d, 0x36,
	0x52, 0xee, 0x3e, 0x7b, 0x91, 0x55, 0x9e, 0xbf, 0xc8, 0x2a, 0xbf, 0xbf, 0xc8, 0x2a, 0x5f, 0xbc,
	0xcc, 0x46, 0x9e, 0xbf, 0xcc, 0x46, 0x7e, 0x7d, 0x99, 0x8d, 0x80, 0xf3, 0x16, 0x9d, 0x39, 0xf1,
	0x0d, 0xe5, 0xfe, 0x46, 0xe8, 0x41, 0x39, 0x81, 0xdc, 0xb0, 0x68, 0x68, 0x55, 0x3c, 0x18, 0xff,
	0x5f, 0xe1, 0x0f, 0xcc, 0x76, 0x8c, 0xff, 0x4f, 0x79, 0xf7, 0xaf, 0x00, 0x00, 0x00, 0xff, 0xff,
	0x7e, 0xec, 0x0d, 0x35, 0x5b, 0x0d, 0x00, 0x00,
}

func (m *Params) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *Params) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *Params) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.UnrestrictedDenomRegex) > 0 {
		i -= len(m.UnrestrictedDenomRegex)
		copy(dAtA[i:], m.UnrestrictedDenomRegex)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.UnrestrictedDenomRegex)))
		i--
		dAtA[i] = 0x1a
	}
	if m.EnableGovernance {
		i--
		if m.EnableGovernance {
			dAtA[i] = 1
		} else {
			dAtA[i] = 0
		}
		i--
		dAtA[i] = 0x10
	}
	if m.MaxTotalSupply != 0 {
		i = encodeVarintMarker(dAtA, i, uint64(m.MaxTotalSupply))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *MarkerAccount) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *MarkerAccount) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *MarkerAccount) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.AllowGovernanceControl {
		i--
		if m.AllowGovernanceControl {
			dAtA[i] = 1
		} else {
			dAtA[i] = 0
		}
		i--
		dAtA[i] = 0x48
	}
	if m.SupplyFixed {
		i--
		if m.SupplyFixed {
			dAtA[i] = 1
		} else {
			dAtA[i] = 0
		}
		i--
		dAtA[i] = 0x40
	}
	if m.MarkerType != 0 {
		i = encodeVarintMarker(dAtA, i, uint64(m.MarkerType))
		i--
		dAtA[i] = 0x38
	}
	{
		size := m.Supply.Size()
		i -= size
		if _, err := m.Supply.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintMarker(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x32
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0x2a
	}
	if m.Status != 0 {
		i = encodeVarintMarker(dAtA, i, uint64(m.Status))
		i--
		dAtA[i] = 0x20
	}
	if len(m.AccessControl) > 0 {
		for iNdEx := len(m.AccessControl) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.AccessControl[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintMarker(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x1a
		}
	}
	if len(m.Manager) > 0 {
		i -= len(m.Manager)
		copy(dAtA[i:], m.Manager)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Manager)))
		i--
		dAtA[i] = 0x12
	}
	if m.BaseAccount != nil {
		{
			size, err := m.BaseAccount.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintMarker(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerAdd) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerAdd) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerAdd) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.MarkerType) > 0 {
		i -= len(m.MarkerType)
		copy(dAtA[i:], m.MarkerType)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.MarkerType)))
		i--
		dAtA[i] = 0x2a
	}
	if len(m.Manager) > 0 {
		i -= len(m.Manager)
		copy(dAtA[i:], m.Manager)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Manager)))
		i--
		dAtA[i] = 0x22
	}
	if len(m.Status) > 0 {
		i -= len(m.Status)
		copy(dAtA[i:], m.Status)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Status)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Amount) > 0 {
		i -= len(m.Amount)
		copy(dAtA[i:], m.Amount)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Amount)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerAddAccess) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerAddAccess) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerAddAccess) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0x12
	}
	{
		size, err := m.Access.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintMarker(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0xa
	return len(dAtA) - i, nil
}

func (m *EventMarkerAccess) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerAccess) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerAccess) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Permissions) > 0 {
		for iNdEx := len(m.Permissions) - 1; iNdEx >= 0; iNdEx-- {
			i -= len(m.Permissions[iNdEx])
			copy(dAtA[i:], m.Permissions[iNdEx])
			i = encodeVarintMarker(dAtA, i, uint64(len(m.Permissions[iNdEx])))
			i--
			dAtA[i] = 0x12
		}
	}
	if len(m.Address) > 0 {
		i -= len(m.Address)
		copy(dAtA[i:], m.Address)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Address)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerDeleteAccess) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerDeleteAccess) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerDeleteAccess) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.RemoveAddress) > 0 {
		i -= len(m.RemoveAddress)
		copy(dAtA[i:], m.RemoveAddress)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.RemoveAddress)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerFinalize) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerFinalize) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerFinalize) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerActivate) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerActivate) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerActivate) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerCancel) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerCancel) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerCancel) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerDelete) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerDelete) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerDelete) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerMint) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerMint) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerMint) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Amount) > 0 {
		i -= len(m.Amount)
		copy(dAtA[i:], m.Amount)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Amount)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerBurn) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerBurn) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerBurn) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Amount) > 0 {
		i -= len(m.Amount)
		copy(dAtA[i:], m.Amount)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Amount)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerWithdraw) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerWithdraw) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerWithdraw) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.ToAddress) > 0 {
		i -= len(m.ToAddress)
		copy(dAtA[i:], m.ToAddress)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.ToAddress)))
		i--
		dAtA[i] = 0x22
	}
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Coins) > 0 {
		i -= len(m.Coins)
		copy(dAtA[i:], m.Coins)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Coins)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerTransfer) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerTransfer) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerTransfer) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.FromAddress) > 0 {
		i -= len(m.FromAddress)
		copy(dAtA[i:], m.FromAddress)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.FromAddress)))
		i--
		dAtA[i] = 0x2a
	}
	if len(m.ToAddress) > 0 {
		i -= len(m.ToAddress)
		copy(dAtA[i:], m.ToAddress)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.ToAddress)))
		i--
		dAtA[i] = 0x22
	}
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Amount) > 0 {
		i -= len(m.Amount)
		copy(dAtA[i:], m.Amount)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Amount)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventMarkerSetDenomMetadata) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventMarkerSetDenomMetadata) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventMarkerSetDenomMetadata) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.MetadataSymbol) > 0 {
		i -= len(m.MetadataSymbol)
		copy(dAtA[i:], m.MetadataSymbol)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.MetadataSymbol)))
		i--
		dAtA[i] = 0x3a
	}
	if len(m.MetadataName) > 0 {
		i -= len(m.MetadataName)
		copy(dAtA[i:], m.MetadataName)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.MetadataName)))
		i--
		dAtA[i] = 0x32
	}
	if len(m.Administrator) > 0 {
		i -= len(m.Administrator)
		copy(dAtA[i:], m.Administrator)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Administrator)))
		i--
		dAtA[i] = 0x2a
	}
	if len(m.MetadataDenomUnits) > 0 {
		for iNdEx := len(m.MetadataDenomUnits) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.MetadataDenomUnits[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintMarker(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x22
		}
	}
	if len(m.MetadataDisplay) > 0 {
		i -= len(m.MetadataDisplay)
		copy(dAtA[i:], m.MetadataDisplay)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.MetadataDisplay)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.MetadataDescription) > 0 {
		i -= len(m.MetadataDescription)
		copy(dAtA[i:], m.MetadataDescription)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.MetadataDescription)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.MetadataBase) > 0 {
		i -= len(m.MetadataBase)
		copy(dAtA[i:], m.MetadataBase)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.MetadataBase)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *EventDenomUnit) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EventDenomUnit) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EventDenomUnit) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Aliases) > 0 {
		for iNdEx := len(m.Aliases) - 1; iNdEx >= 0; iNdEx-- {
			i -= len(m.Aliases[iNdEx])
			copy(dAtA[i:], m.Aliases[iNdEx])
			i = encodeVarintMarker(dAtA, i, uint64(len(m.Aliases[iNdEx])))
			i--
			dAtA[i] = 0x1a
		}
	}
	if len(m.Exponent) > 0 {
		i -= len(m.Exponent)
		copy(dAtA[i:], m.Exponent)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Exponent)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Denom) > 0 {
		i -= len(m.Denom)
		copy(dAtA[i:], m.Denom)
		i = encodeVarintMarker(dAtA, i, uint64(len(m.Denom)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func encodeVarintMarker(dAtA []byte, offset int, v uint64) int {
	offset -= sovMarker(v)
	base := offset
	for v >= 1<<7 {
		dAtA[offset] = uint8(v&0x7f | 0x80)
		v >>= 7
		offset++
	}
	dAtA[offset] = uint8(v)
	return base
}
func (m *Params) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.MaxTotalSupply != 0 {
		n += 1 + sovMarker(uint64(m.MaxTotalSupply))
	}
	if m.EnableGovernance {
		n += 2
	}
	l = len(m.UnrestrictedDenomRegex)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *MarkerAccount) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.BaseAccount != nil {
		l = m.BaseAccount.Size()
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Manager)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	if len(m.AccessControl) > 0 {
		for _, e := range m.AccessControl {
			l = e.Size()
			n += 1 + l + sovMarker(uint64(l))
		}
	}
	if m.Status != 0 {
		n += 1 + sovMarker(uint64(m.Status))
	}
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = m.Supply.Size()
	n += 1 + l + sovMarker(uint64(l))
	if m.MarkerType != 0 {
		n += 1 + sovMarker(uint64(m.MarkerType))
	}
	if m.SupplyFixed {
		n += 2
	}
	if m.AllowGovernanceControl {
		n += 2
	}
	return n
}

func (m *EventMarkerAdd) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Amount)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Status)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Manager)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.MarkerType)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerAddAccess) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = m.Access.Size()
	n += 1 + l + sovMarker(uint64(l))
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerAccess) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Address)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	if len(m.Permissions) > 0 {
		for _, s := range m.Permissions {
			l = len(s)
			n += 1 + l + sovMarker(uint64(l))
		}
	}
	return n
}

func (m *EventMarkerDeleteAccess) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.RemoveAddress)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerFinalize) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerActivate) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerCancel) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerDelete) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerMint) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Amount)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerBurn) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Amount)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerWithdraw) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Coins)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.ToAddress)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerTransfer) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Amount)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.ToAddress)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.FromAddress)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventMarkerSetDenomMetadata) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.MetadataBase)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.MetadataDescription)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.MetadataDisplay)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	if len(m.MetadataDenomUnits) > 0 {
		for _, e := range m.MetadataDenomUnits {
			l = e.Size()
			n += 1 + l + sovMarker(uint64(l))
		}
	}
	l = len(m.Administrator)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.MetadataName)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.MetadataSymbol)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	return n
}

func (m *EventDenomUnit) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Denom)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	l = len(m.Exponent)
	if l > 0 {
		n += 1 + l + sovMarker(uint64(l))
	}
	if len(m.Aliases) > 0 {
		for _, s := range m.Aliases {
			l = len(s)
			n += 1 + l + sovMarker(uint64(l))
		}
	}
	return n
}

func sovMarker(x uint64) (n int) {
	return (math_bits.Len64(x|1) + 6) / 7
}
func sozMarker(x uint64) (n int) {
	return sovMarker(uint64((x << 1) ^ uint64((int64(x) >> 63))))
}
func (m *Params) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: Params: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: Params: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaxTotalSupply", wireType)
			}
			m.MaxTotalSupply = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MaxTotalSupply |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field EnableGovernance", wireType)
			}
			var v int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				v |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			m.EnableGovernance = bool(v != 0)
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field UnrestrictedDenomRegex", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.UnrestrictedDenomRegex = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *MarkerAccount) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: MarkerAccount: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: MarkerAccount: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field BaseAccount", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.BaseAccount == nil {
				m.BaseAccount = &types.BaseAccount{}
			}
			if err := m.BaseAccount.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Manager", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Manager = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field AccessControl", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.AccessControl = append(m.AccessControl, AccessGrant{})
			if err := m.AccessControl[len(m.AccessControl)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Status", wireType)
			}
			m.Status = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Status |= MarkerStatus(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 6:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Supply", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Supply.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 7:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MarkerType", wireType)
			}
			m.MarkerType = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MarkerType |= MarkerType(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 8:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field SupplyFixed", wireType)
			}
			var v int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				v |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			m.SupplyFixed = bool(v != 0)
		case 9:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field AllowGovernanceControl", wireType)
			}
			var v int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				v |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			m.AllowGovernanceControl = bool(v != 0)
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerAdd) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerAdd: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerAdd: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Amount", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Amount = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Status", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Status = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Manager", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Manager = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MarkerType", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.MarkerType = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerAddAccess) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerAddAccess: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerAddAccess: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Access", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Access.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerAccess) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerAccess: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerAccess: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Address", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Address = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Permissions", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Permissions = append(m.Permissions, string(dAtA[iNdEx:postIndex]))
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerDeleteAccess) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerDeleteAccess: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerDeleteAccess: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field RemoveAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.RemoveAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerFinalize) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerFinalize: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerFinalize: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerActivate) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerActivate: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerActivate: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerCancel) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerCancel: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerCancel: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerDelete) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerDelete: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerDelete: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerMint) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerMint: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerMint: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Amount", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Amount = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerBurn) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerBurn: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerBurn: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Amount", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Amount = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerWithdraw) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerWithdraw: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerWithdraw: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Coins", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Coins = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ToAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ToAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerTransfer) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerTransfer: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerTransfer: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Amount", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Amount = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ToAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ToAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field FromAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.FromAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventMarkerSetDenomMetadata) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventMarkerSetDenomMetadata: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventMarkerSetDenomMetadata: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MetadataBase", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.MetadataBase = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MetadataDescription", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.MetadataDescription = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MetadataDisplay", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.MetadataDisplay = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MetadataDenomUnits", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.MetadataDenomUnits = append(m.MetadataDenomUnits, &EventDenomUnit{})
			if err := m.MetadataDenomUnits[len(m.MetadataDenomUnits)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Administrator", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Administrator = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 6:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MetadataName", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.MetadataName = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 7:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MetadataSymbol", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.MetadataSymbol = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *EventDenomUnit) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EventDenomUnit: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EventDenomUnit: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Denom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Denom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Exponent", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Exponent = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Aliases", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthMarker
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthMarker
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Aliases = append(m.Aliases, string(dAtA[iNdEx:postIndex]))
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipMarker(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthMarker
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func skipMarker(dAtA []byte) (n int, err error) {
	l := len(dAtA)
	iNdEx := 0
	depth := 0
	for iNdEx < l {
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return 0, ErrIntOverflowMarker
			}
			if iNdEx >= l {
				return 0, io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		wireType := int(wire & 0x7)
		switch wireType {
		case 0:
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				iNdEx++
				if dAtA[iNdEx-1] < 0x80 {
					break
				}
			}
		case 1:
			iNdEx += 8
		case 2:
			var length int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowMarker
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				length |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if length < 0 {
				return 0, ErrInvalidLengthMarker
			}
			iNdEx += length
		case 3:
			depth++
		case 4:
			if depth == 0 {
				return 0, ErrUnexpectedEndOfGroupMarker
			}
			depth--
		case 5:
			iNdEx += 4
		default:
			return 0, fmt.Errorf("proto: illegal wireType %d", wireType)
		}
		if iNdEx < 0 {
			return 0, ErrInvalidLengthMarker
		}
		if depth == 0 {
			return iNdEx, nil
		}
	}
	return 0, io.ErrUnexpectedEOF
}

var (
	ErrInvalidLengthMarker        = fmt.Errorf("proto: negative length found during unmarshaling")
	ErrIntOverflowMarker          = fmt.Errorf("proto: integer overflow")
	ErrUnexpectedEndOfGroupMarker = fmt.Errorf("proto: unexpected end of group")
)
