package keeper

import (
	sdk "github.com/cosmos/cosmos-sdk/types"

	"github.com/provenance-io/provenance/x/msgfees/types"
)

// GetParams returns the total set of distribution parameters.
func (k Keeper) GetParams(ctx sdk.Context) (params types.Params) {
	return types.Params{
		FloorGasPrice:      k.GetFloorGasPrice(ctx),
		NhashPerUsdMil:     k.GetNhashPerUsdMil(ctx),
		ConversionFeeDenom: k.GetConversionFeeDenom(ctx),
	}
}

// SetParams sets the account parameters to the param space.
func (k Keeper) SetParams(ctx sdk.Context, params types.Params) {
	k.paramSpace.SetParamSet(ctx, &params)
}
